<template>
  <div>
    <ob-select
      class="mb20"
      :label="'Частота перерасчета'"
      :items="frequencyItems"
      v-model="frequency"
    />
    <slot v-if="frequency === 'everyday'">
      <ob-select
        v-model="time"
        :label="'Время'"
        class="half-width mb20"
        :items="timeItems"
        placeholder="01:00"
      />
    </slot>

    <slot v-if="frequency === 'onceperweek'">
      <ob-select
        class="mb20"
        :label="'Частота перерасчета'"
        :items="daysOfWeekItems"
        v-model="daysOfWeek"
        placeholder="Понедельник"
      />
      <ob-select
        v-model="time"
        :label="'Время'"
        class="half-width mb20"
        :items="timeItems"
        placeholder="01:00"
      />
    </slot>

    <slot v-if="frequency === 'now'">
      <ob-select class="mb20" :label="'Ответственный'" placeholder="Петренко В.Ф." disabled />
      <ob-select class="mb20" :label="'Дата и время отключения'" placeholder="01.01.2021" disabled />

      <p>Пересчет будет начат сразу после нажатия на кнопку “Пересчитать”. Операция пересчета может занять несколько часов. Во время пересчета скорость работы модуля БЦ может существенно снизиться.</p>
    </slot>

    <slot v-if="frequency === 'disable'">
      <ob-select class="mb20" :label="'Ответственный'" placeholder="Петренко В.Ф." disabled />
      <ob-select class="mb20" :label="'Дата и время отключения'" placeholder="01.01.2021" disabled />
    </slot>
    <p>Последний пересчет производится 08.11.2019 в 01:00</p>
    <slot v-if="frequency === 'disable'">
      <p
        style="color: red;"
      >Внимание! Отключение перерасчета приведет к полной остановке актуализации базовых цен для всех направлений во всей системе. Перерасчет будет остановлен с момента отключения.</p>
    </slot>
  </div>
</template>

<script>
import ObSelect from 'common-components/src/obComponents/obSelect';

const SECONDS_IN_MINUTE = 60;
const MINUTES_IN_HOUR = 60;
const MILLISECOND_IN_SECOND = 1000;

export default {
  name: 'PlannerModal',
  components: {
    ObSelect,
  },
  mixins: [],
  mounted() {},
  computed: {
    timeItems() {
      let items = [];

      for (let i = 0; i < 24; i++) {
        items.push({
          uuid: i * MINUTES_IN_HOUR * SECONDS_IN_MINUTE * MINUTES_IN_HOUR,
          title: i + ':00',
        });
        items.push({
          uuid:
            (i * MINUTES_IN_HOUR + MINUTES_IN_HOUR / 2) *
            SECONDS_IN_MINUTE *
            MILLISECOND_IN_SECOND,
          title: i + ':30',
        });
      }
      return items;
    },
  },
  data() {
    return {
      frequencyItems: [
        {
          uuid: 'everyday',
          title: 'Ежедневно',
        },
        {
          uuid: 'onceperweek',
          title: 'Раз в неделю',
        },
        {
          uuid: 'now',
          title: 'Пересчитать сейчас',
        },
        {
          uuid: 'disable',
          title: 'Отключить перерасчет',
          className: 'danger',
        },
      ],
      daysOfWeekItems: [
        {
          title: 'Понедельник',
        },
        {
          title: 'Вторник',
        },
        {
          title: 'Среда',
        },
        {
          title: 'Четверг',
        },
        {
          title: 'Пятница',
        },
        {
          title: 'Суббота',
        },
        {
          title: 'Воскресенье',
        },
      ],
      frequency: 'everyday',
      daysOfWeek: 'Понедельник',
      time: '01:00',
      className: 'danger',
    };
  },
  methods: {},
};
</script>

<style lang="scss" scoped>
.half-width {
  width: 50%;
}
.mb20 {
  margin-bottom: 20px;
}
</style>